#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

//a)

typedef struct aautomobil{
	char rega[11];
	char ozn;
	stuct aautomobil *next;
} automobil;

//b)

automobil* dodaj(automobil* first){
	automobil* new = malloc(sizeof(automobil));
	automobil* pom;

	scanf("%s", new->rega);
	scanf(" %c", &new->ozn);

	//prvi slucaj: ako je lista prazna, ubacujemo na prvo mjesto
	if(first == NULL){
		new->next = NULL;
		return new;
	}

	//drugi slucaj: ako prvi automobil ima tu oznaku, ubacujemo na prvo mjesto
	if(first->ozn == new->ozn){
		new->next = first;
		first = new;
		return first;
	}

	//treci slucaj: trazimo mjesto na koje trebamo ubaciti novi element
	pom = first;
	while(pom->next != NULL){
		if(pom->next->rega == new->rega){
			new->next = pom->next->next;
			pom->next = new;
			return first;
		}
		pom = pom->next;

	}

	/*ako nismo izasli u prva tri slucaja, onda nema takve oznake u listi,
	stoga ubacujemo na prvo mjesto*/

	new -> next = first;
	return new;
}

//c)
//Napisat cemo posebnu funkciju za provjeru formata
int ispravna(char* reg){
	if(!isupper(reg[0]) || !isupper(reg[1])) return 0;
	if(reg[2] != '-') return 0;
	for(i = 3; i < 7; ++i) if(!isupper(reg[i])) return 0;
	if(reg[7] != '-') return 0;
	if(!isupper(reg[8]) || !isupper(reg[9])) return 0;
	return 1;
}

automobil* izbaci(automobil* first){
	automobil* pom;
	//najprije izbacujemo elemente s prve pozicije
	while(first != NULL && !ispravna(first->rega)){
		pom = first;
		first = first->next;
		free(pom);
	}

//do sada smo izbacili sve "krive" elemente s pocetka
	if(first == NULL) return first; //moguce je da smo time ispraznili listu
	pom = first;
	while(pom->next != NULL){
		automobil *del;
		if(!ispravna(pom->next->rega)){
			del = pom->next;
			pom->next = pom->next->next;
			free(del);
		}
	}
	return first;
}

//d)
automobil* iskrcavanje(automobil* first, char lu){
	automobil* pom;
	automobil* del;
	int gotovo = 0;

	if(first == NULL) return NULL;
	//mozda blok kojeg trebamo izbaciti pocinje s prvim elementom:
	while(first!= NULL && first -> ozn == lu){
		del = first;
		first = first->next;
		free(del);
		gotovo = 1;
	}

	if(gotovo) return first;

	//u suprotnom, blok pocinje negdje u sredini liste; kod je isti kao u c)
	pom = first;
	while(pom->next != NULL){
		automobil *del;
		if(pom->next->ozn == lu){
			del = pom->next;
			pom->next = pom->next->next;
			free(del);
		}
	}

	return first;
}