#include <stdio.h>

/* racunanje broja nacina prema nazad - od zadnje daske do prve */
/* pretpostavka je da je daske[n+1] definiran i jednak 0 */
int rek1(int n, int daske[])
{
    if (n == 0) return 1;
    if (n < 0) return 0;

    if (daske[n]) return 0; /* na ovu dasku se ne moze stati */

    return rek1(n-1, daske) + rek1(n-2, daske) + rek1(n-3, daske);
}

/* racunanje broja nacina prema naprijed - od prve daske do zadnje */
int rek2(int korak, int n, int daske[])
{
    if (korak == n+1) return 1;
    if (korak > n+1) return 0;

    if (daske[korak]) return 0; /* na ovu dasku se ne moze stati */

    return rek2(korak+1, n, daske) + rek2(korak+2, n, daske) +
            rek2(korak+3, n, daske);
}

int main()
{
    int daske[] = {0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0};
		/* zadnja nula je dodana radi jednostavnosti rjesenja */

    printf("%d\n", rek1(11+1, daske));
    printf("%d\n", rek2(0, 11, daske));

    return 0;
}
